Unit QSL2R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTQS10_p;

procedure QSL2R(var INT :Real; var A :Real; var B :Real; F :Func_F1;
                var E :Real);

implementation

procedure QSL2R(var INT :Real; var A :Real; var B :Real; F :Func_F1;
                var E :Real);
var
U,V,X,BI,IERR :Integer;
EPS,C,D,K,O,BA,W,J1,Z2,H,Z1,P,BF,BG,BH,BD,BE,L,Q,R,J,S,M,E1 :Real;
NI,Y,Z :Boolean;
AY :Array [0..6] of Real;
BY :Array [0..6] of Real;
KSI :Array [0..6] of Real;
OM :Array [0..2] of Integer;
BB :Array [0..2] of Real;
const
SYS093 :Real = 0.999999;
HMIN :Real = 1.0E-3;
SYS051 :Real = 1.192093E-7;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27,_28,_29,_30,_31,_32,_33,_34,_35,_36,
_50,_37,_38;
begin
{   DATA  FORTRAN  }
AY[0] := 0.023809;
AY[1] := 0.243809;
AY[2] := 0.023809;
AY[3] := 0.138413;
AY[4] := 0.215872;
AY[5] := 0.215872;
AY[6] := 0.138413;
BY[0] := -0.076190;
BY[1] := 0.243809;
BY[2] := -0.076190;
BY[3] := 0.183701;
BY[4] := -0.229416;
BY[5] := -0.229416;
BY[6] := 0.183701;
KSI[0] := 0.0;
KSI[1] := 0.5;
KSI[2] := 1.0;
KSI[3] := 0.084888;
KSI[4] := 0.265575;
KSI[5] := 0.734424;
KSI[6] := 0.915111;
V := 2;
Y := True;
X := 1;
E1 := E;
EPS := Abs(E);
C := 0.0;
D := 0.0;
if ( B-100.0 ) < 0
 then goto _3
 else if ( B-100.0 ) > 0
       then goto _1
       else goto _1;
_1:
if ( A+100.0 ) < 0
 then goto _2
 else if ( A+100.0 ) > 0
       then goto _23
       else goto _2;
_2:
Y := False;
X := -1;
K := B;
E := E/2.0;
B := A;
A := 0.0;
goto _23;
_3:
X := -1;
O := A;
A := B;
B := O;
goto _23;
_4:
NI := ( A  > B );
if (  not ( (NI) ) ) 
 then goto _5;
BA := A;
A := B;
B := BA;
_5:
W := B-A;
if (  not ( (W  = 0.0) ) ) 
 then goto _6;
J1 := 0.0;
goto _22;
_6:
Z2 := E/W;
H := 1.0;
Z1 := EPS/W;
P := 0.0;
J1 := 0.0;
OM[0] := 0;
OM[1] := 0;
OM[2] := 0;
_7:
BF := P+H;
BG := 0.0;
BH := 0.0;
for BI:=1 to 3 do
 begin
  if ( OM[BI-1]  = 0 ) 
   then goto _8;
  BD := BB[BI-1];
  goto _9;
_8:
  BE := H*KSI[BI-1]+P;
  BB[BI-1] := F(W*BE+A);
  BD := BB[BI-1];
  OM[BI-1] := 1;
_9:
  BG := BG+AY[BI-1]*BD;
  BH := BH+BY[BI-1]*BD;
_10:
 end;
for BI:=4 to 7 do
 begin
  BE := H*KSI[BI-1]+P;
  BD := F(W*BE+A);
  BG := BG+AY[BI-1]*BD;
  BH := BH+BY[BI-1]*BD;
_11:
 end;
BG := H*BG;
BH := Abs(H*BH);
if ( H  <= HMIN ) 
 then goto _50;
if ( BH-Z1 ) < 0
 then goto _12
 else if ( BH-Z1 ) > 0
       then goto _18
       else goto _18;
_12:
P := BF;
_13:
J1 := J1+BG;
BD := 1.0-P;
if ( 1.0+BD/64.0-1.0 ) < 0
 then goto _21
 else if ( 1.0+BD/64.0-1.0 ) > 0
       then goto _14
       else goto _21;
_14:
BB[0] := BB[2];
OM[1] := 0;
OM[2] := 0;
OM[0] := 1;
if ( BH-Z1/IntPower(2.0,7) ) < 0
 then goto _15
 else if ( BH-Z1/IntPower(2.0,7) ) > 0
       then goto _16
       else goto _16;
_15:
H := 2.0*H;
_16:
if ( H-BD ) < 0
 then goto _7
 else if ( H-BD ) > 0
       then goto _17
       else goto _7;
_17:
H := BD;
goto _7;
_18:
H := H/2.0;
if ( H  > SYS051*P ) 
 then goto _20;
_19:
P := P+H*2.0;
H := H*2.0;
goto _13;
_20:
BB[2] := BB[1];
OM[1] := 0;
goto _7;
_21:
J1 := J1*W;
if (  not ( (NI) ) ) 
 then goto _22;
BA := B;
B := A;
A := BA;
_22:
case U of
 1: goto _27;
 2: goto _31;
end;
_23:
J := B;
L := A;
_24:
B := L+V*X;
if ( (B-J)*X ) < 0
 then goto _26
 else if ( (B-J)*X ) > 0
       then goto _25
       else goto _26;
_25:
B := J;
_26:
U := 1;
goto _4;
_27:
INT := J1;
Q := Abs(J1);
_28:
Z := False;
R := Q;
A := B;
B := L+(B-L)*V;
if ( (B-J)*X ) < 0
 then goto _30
 else if ( (B-J)*X ) > 0
       then goto _29
       else goto _30;
_29:
B := J;
_30:
U := 2;
goto _4;
_31:
INT := INT+J1;
Q := Abs(J1);
if ( Q  = 0.0  ) and ( R  = 0.0 ) 
 then goto _33;
if ( Q-SYS093*R ) < 0
 then goto _32
 else if ( Q-SYS093*R ) > 0
       then goto _28
       else goto _28;
_32:
S := Q/R;
S := Q*S/(1.0-S);
if ( S-E ) < 0
 then goto _33
 else if ( S-E ) > 0
       then goto _28
       else goto _28;
_33:
if (  not ( (Z) ) ) 
 then goto _34;
goto _35;
_34:
Z := True;
_35:
A := L;
B := J;
C := C+INT;
D := C;
if ( Y ) 
 then goto _38;
if ( X+1 ) < 0
 then goto _36
 else if ( X+1 ) > 0
       then goto _37
       else goto _36;
_36:
M := B;
B := K;
X := 1;
goto _23;
_50:
IERR := 65;
E := E1;
UTQS10(IERR,15);
goto _38;
_37:
A := M;
E := 2.0*E;
_38:
INT := D;
end;

end.
